% Matlab equation file: "SIP_ABCD_eqns.m"
% Open-Loop State-Space Matrices: A, B, C, and D
% for the Quanser Single Inverted Pendulum Experiment.

A = [0 0 0 1 0 0;
     0 0 0 0 1 0;
     0 0 0 0 0 1;
     0 lsp^2*g*(2*Jfp*Msp*Mfp+Jfp*Msp^2+Jfp*Mfp^2+Mfp^2*lfp^2*Msp+Mfp*lfp^2*Msp^2)/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp)...
     Jsp*Mfp*lfp*(Mfp*g*lfp-Ks)/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp) 0 0 0;
     0 g*(Mfp^2*lfp^2*Msp+Jfp*Msp*Mc+Jfp*Msp^2+Mfp*lfp^2*Msp*Mc+Mfp*lfp^2*Msp^2+Jfp*Mfp^2+Jfp*Mfp*Mc+2*Jfp*Msp*Mfp+Mc*Mfp^2*lfp^2)*lsp/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp)...
     -Mfp*lfp*Mc*(Mfp*g*lfp-Ks)*lsp/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp) 0 0 0;
     0 -lsp^2*Mfp*g*lfp*Mc*(Msp+Mfp)/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp)...
     (Msp*Jsp*Mfp*lfp*g+Mc*Mfp*lfp*Msp*lsp^2*g+Mc*Jsp*Mfp*lfp*g-lsp^2*Mc*Mfp*Ks-Msp*Jsp*Ks-Mc*Jsp*Ks-lsp^2*Msp*Mc*Ks+Jsp*Mfp^2*lfp*g+lsp^2*Mfp^2*g*lfp*Mc-Jsp*Mfp*Ks)/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp)...
     0 0 0];
B = [0; 0; 0; (Jsp*Jfp+Jfp*Msp*lsp^2+Jfp*Mfp*lsp^2+Mfp*lfp^2*Msp*lsp^2+Jsp*Mfp*lfp^2)/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp);...
    (Jfp*Msp+Mfp*lfp^2*Msp+Jfp*Mfp)*lsp/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp);...
    Jsp*Mfp*lfp/(Jsp*Jfp*Mfp+Jsp*Jfp*Mc+Jsp*Jfp*Msp+Jfp*Msp*lsp^2*Mc+Jfp*Mfp*lsp^2*Mc+Mfp*lfp^2*Msp*lsp^2*Mc+Jsp*Mfp*lfp^2*Mc+Jsp*Mfp*lfp^2*Msp)];
C = eye(3,6);
D = zeros(3,1);

%Actuator Dynamics
A(4,4) = A(4,4) - B(4)*eta_g*Kg^2*eta_m*Kt*Km/r_mp^2/Rm;
A(5,4) = A(5,4) - B(5)*eta_g*Kg^2*eta_m*Kt*Km/r_mp^2/Rm;
A(6,4) = A(6,4) - B(6)*eta_g*Kg^2*eta_m*Kt*Km/r_mp^2/Rm;
B = eta_g*Kg*eta_m*Kt/r_mp/Rm*B;